package clews.data;

import java.util.ArrayList;

import clews.env.Environment;
import clews.gui.view.ClassView;

public class Class
extends DataObject<ClassView>
{

	protected Specification spec;
	protected String name;
	protected int minobj,weight,maxobj,minpartner,maxpartner;
	protected int minmodelobj;
	protected boolean isConsistent;
	protected ArrayList<AssociationEnd> ends;
	
	public Class(Specification s)
	{
		this(s,Environment.NO_CLASS_ID);
	}
	
	public Class(Specification s, int oid)
	{
		ends = new ArrayList<AssociationEnd>();
		isConsistent = true;
		spec = s;
		if (oid != Environment.NO_CLASS_ID)
			this.id = oid;
		name = "Class"+this.id;
		weight = 1;
		maxobj = Environment.CARDINALITY_STAR;
		minpartner = 0;
		maxpartner = Environment.CARDINALITY_STAR;
	}
	
	public int getMaxObj(){
		return maxobj;
	}
	
	public void setMaxObj(int mo){
		maxobj = mo;
	}
	
	public void setMinPartner(int mp){
		if (mp >= 0)
			minpartner = mp;
	}
	
	public int getMinPartner(){
		return minpartner;		
	}
	
	public void setMaxPartner(int mp){
		maxpartner = mp;
		if (mp != Environment.CARDINALITY_STAR)
			maxpartner = Math.max(getMinPartner(), mp);
	}
	
	public int getMaxParnter(){
		return maxpartner;
	}
	
	public void setWeight(int w)
	{
		weight = w;
	}
	
	public int getWeight()
	{
		return weight;
	}
	
	public void addAssociationEnd(AssociationEnd ae)
	{
		ends.add(ae);
	}
	
	public ArrayList<AssociationEnd> getEnds()
	{
		return ends;
	}
	
	public boolean isConsistent()
	{
		return isConsistent;
	}
	
	public void setIsConsistent(boolean val)
	{
		isConsistent = val;
	}
		
	public Specification getSpecification()
	{
		return spec;
	}
	
	public String getName()
	{
		return name;
	}
	
	public void setName(String str)
	{
		name = str;
	}
		
	public void setMinObj(int nr)
	{
		minobj = nr;
	}
	
	public void setMinModelObj(int nr)
	{
		minmodelobj = nr;
	}
	
	public int getMinObj()
	{
		return minobj;
	}
	
	public int getMinModelObj()
	{
		return minmodelobj;
	}
	
	public String toString()
	{
		return getName();
	}


}
