package clews.data;

import java.util.HashMap;

import clews.gui.view.ViewObject;

public abstract class DataObject<V extends ViewObject> 
implements Cloneable
{
	protected V view;
	protected int id;
	protected static HashMap<java.lang.Class<?>, Number> RUNNINGID;
	
	public DataObject()
	{
		view = null;
		if (!RUNNINGID.containsKey(this.getClass()))
			RUNNINGID.put(this.getClass(), 0);
		id = RUNNINGID.get(this.getClass()).intValue()+1;
		RUNNINGID.put(this.getClass(), id); 
	}	
	
	public static void setId(java.lang.Class<?> type, int id)
	{
		if (id != Integer.MIN_VALUE && id != Integer.MAX_VALUE && id > RUNNINGID.get(type).intValue()){
			if (RUNNINGID.containsKey(type))
				RUNNINGID.remove(type);
			RUNNINGID.put(type, id);
		}
	}
	
	public static void resetIds()
	{
		RUNNINGID = new HashMap<java.lang.Class<?>, Number>();
	}
	
	public void setId(int newId)
	{
		id = newId;
	}
	
	public int getId()
	{
		return id;
	}	
	
	public V getView()
	{
		return view;
	}
	
	public void setView(V v)
	{
		view = v;
	}
	
	public boolean hasView()
	{
		return true;
	}
}
