package clews.env;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Shape;
import java.awt.font.FontRenderContext;
import java.awt.font.TextLayout;
import java.awt.geom.AffineTransform;

import javax.swing.JDialog;

public class Environment {
	
	public static Color CLASS_COLOR = Color.BLACK;
	public static Color CLASS_COLOR_INCONSISTENT = Color.RED;
	public static Color CLASS_INTERIOUR_COLOR = Color.WHITE;
	public static Color MOUSE_OVER_CLASS_COLOR = Color.BLUE;
	public static Color MARKED_CLASS_COLOR = Color.BLUE;
	
	public static Color ASSOCIATION_COLOR = Color.BLACK;
	public static Color MOUSE_OVER_ASSOCIATION_COLOR = Color.BLUE;
	public static Color MARKED_ASSOCIATION_COLOR = Color.BLUE;
	public static Color ASSOCIATION_CONSTRAINT = Color.RED;
	public static double ASSOCIATION_PICKING_SENSITVITY = 3.5;
	
	public static double USER_ZOOM_IN = 1.1;
	public static double USER_ZOOM_OUT = 0.9;
	public static int USER_TRANSLATION = 100;
	
	public static Color DIAGRAM_BACKGROUND = Color.WHITE;
	public static Color DIAGRAM_SELECTED_BACKGROUND = Color.WHITE;
	

	public static int NO_CLASS_ID = -1;
	public static int CARDINALITY_STAR = -1;
	
	public static float DIAGRAM_SELECTION_ALPHA =0.25f;
	public static float CLASS_SELECTION_ALPHA = 0.50f;
	public static float ASSOCIATION_SELECTION_ALPHA = 0.50f;
	
	public static int PRINT_SPACING = 10;
	public static boolean IS_CONTROL_DOWN = false;

	public static String DOMAIN_ENDING = "cld";
	public static String SPECIFICATION_ENDING = "cls";
	public static String CONFIGURATION_ENDING = "clc";
	
	public static String ASSOCIATION_INVERSE = "^-1";
	public static ViewDetails VIEW_DETAILS = ViewDetails.ALL;
	
	public static String HISTORY_PATH = ".history";
	public static BasicStroke DASHED = new BasicStroke(1.0f, 
             BasicStroke.CAP_BUTT, 
             BasicStroke.JOIN_MITER, 
             5.0f, new float[]{5.0f}, 0.0f);

	public static JDialog CURRENT_DIALOG = null;
	
	public enum ViewDetails
	{
		ALL,
		SOME,
		NO
	}
	
	public static Shape getText(String text, int size, int type)
	{
		TextLayout textTl = new TextLayout(text, new Font("SansSerif", type, size), 
	            new FontRenderContext(null, true, true));
        AffineTransform textAt = new AffineTransform();
        textAt.translate(0, (float)textTl.getBounds().getHeight());        
        return textTl.getOutline(textAt);	
	}
	

	public static Shape getItalicText(String text)
	{
		return getText(text,13,Font.ITALIC);
	}
	
	public static Shape getBoldText(String text)
	{
		return getText(text,16,Font.BOLD);
	}
	
	public static Shape getStandardText(String text)
	{
        return getText(text,16,Font.PLAIN);
	}
	
	public static Shape getSmallText(String text)
	{
		return getText(text,13,Font.PLAIN);
	}
}
