package clews.export;

import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Node;

import clews.Domain;
import clews.MainFrame;
import clews.data.Configuration;
import clews.env.Environment;
import clews.gui.diagram.SpecificationDiagram;

public class DomainXMLExport 
extends XMLExport 
{
	protected Domain domain;
	protected static String ClewsSeperator = "\\";
	
	public DomainXMLExport(Domain d)
	{
		domain = d;
	}
	
	public boolean saveToDisk(String path) 
	{
		return saveToDisk(path,false);
	}
	
	public boolean saveToDisk(String path, boolean isTmp) 
	{
		try {
			// TODO
			if (!isTmp)
			{
				domain.setPath(null);
				domain.getSpecification().setPath(null);
				for (Configuration c : domain.getConfigurations())
					c.setPath(null);
			}
			
	        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
			DocumentBuilder builder;		
			builder = factory.newDocumentBuilder();
	        doc = builder.newDocument();
	        doc.setXmlStandalone(true);			
        
	        SpecificationXMLExport sxe = new SpecificationXMLExport(domain.getSpecification());
	        String spath = path.replace("."+Environment.DOMAIN_ENDING, "."+Environment.SPECIFICATION_ENDING);
	        if (!sxe.save(spath,isTmp))
	        	throw new Exception("Error while saving specification");
	        
        	Node main = doc.createElement("domain");
	        if (MainFrame.getInstance().getDiagramPanel() != null){
		        addAttribute(main, "active", MainFrame.getInstance().getDiagramPanel().getDiagram().getName());	        
		        if (isTmp) addAttribute(main, "tmppath", domain.getPath());
	        }

	        Node cur = doc.createElement("specification");	        
	        if (isTmp) addAttribute(cur, "tmppath", domain.getSpecification().getPath());
	        addAttribute(cur, "path", "."+File.separator+(new File(domain.getSpecification().getPath())).getName());
	        main.appendChild(cur);
	        
	        Node configs = doc.createElement("configurations");
	        for (Configuration c : domain.getConfigurations())
			{
				cur = doc.createElement("configuration");
				addAttribute(cur,"name",c.getName());

				if (isTmp) addAttribute(cur, "tmppath", c.getPath());
				ConfigurationXMLExport cxe = new ConfigurationXMLExport(c);
				cxe.save(path,isTmp);
				addAttribute(cur,"path","."+File.separator+(new File(c.getPath())).getName());
				configs.appendChild(cur);
			}
			main.appendChild(configs);
			doc.appendChild(main);
	        toDisk(path);	        
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}
		domain.setPath(path);
		return true;
	}
}
