package clews.export;

import java.io.File;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Node;

public abstract class XMLExport {
	protected Document doc;

	public abstract boolean saveToDisk(String path);
	
	protected void addAttribute(Node n, String name, String val)
	{
		Attr a = doc.createAttribute(name);
		a.setNodeValue(val);
		n.getAttributes().setNamedItem(a);
	}
	
	protected void toDisk(String path) throws Exception
	{
		TransformerFactory tranFact = TransformerFactory.newInstance();
		Transformer transfor = tranFact.newTransformer();
		transfor.setOutputProperty(OutputKeys.INDENT, "yes");
		transfor.setOutputProperty("{http://xml.apache.org/xslt}indent-amount", "2");
		
		DOMSource src = new DOMSource(doc);
		StreamResult dest = new StreamResult(new File(path));
		transfor.transform(src, dest);			
	}
}
