package clews.gui;

import java.io.File;
import java.util.Hashtable;

import javax.swing.filechooser.FileFilter;

public class CustomFileFilter extends FileFilter{

	protected Hashtable<String,String> extensions;
	protected String description;
	
	public CustomFileFilter(String[] ext, String desc)
	{
		extensions = new Hashtable<String, String>();
		for (int i=0;i<ext.length;i++)
			extensions.put(ext[i], ext[i]);
		description = desc;
	}
	
	@Override
	public boolean accept(File f) {
		if(f != null) {
		    if(f.isDirectory())
		    	return true;
		    String extension = getExtension(f);
		    if(extension != null && extensions.get(getExtension(f)) != null)
		    	return true;
		}
		return false;
	}
	
    public String getExtension(File f) {
    	if(f != null) {
    	    String filename = f.getName();
    	    int i = filename.lastIndexOf('.');
    	    if(i>0 && i<filename.length()-1)
    	    	return filename.substring(i+1).toLowerCase();
    	}
    	return null;
    }


	@Override
	public String getDescription() {
		return description;
	}

}
