package clews.gui;

import java.awt.dnd.DnDConstants;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JTree;
import javax.swing.tree.TreePath;

import clews.MainFrame;
import clews.data.Association;
import clews.data.Configuration;
import clews.data.Constraint;

public class DomainTree extends JTree 
implements MouseListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6855480194003030728L;
	protected TreePath rootSelPath;
	protected TreeDragSource ds;
	protected MainFrame mainFrame;

	public DomainTree(MainFrame mf) 
	{
		super();		
		mainFrame = mf;
		addMouseListener(this);	
		ds = new TreeDragSource(this, DnDConstants.ACTION_COPY);		
	}

	@Override
	public void mouseClicked(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseEntered(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mouseExited(MouseEvent e) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void mousePressed(MouseEvent e) {
		// TODO Auto-generated method stub
		 int selRow = getRowForLocation(e.getX(), e.getY());
         TreePath selPath = getPathForLocation(e.getX(), e.getY());
//         System.out.println(selRow);
         rootSelPath = null;
         if(selRow != -1) {
             if(e.getClickCount() == 1) {
                 //mySingleClick(selRow, selPath);
  //               System.out.println(selPath.getLastPathComponent());                 
             }
             else if(e.getClickCount() == 2) {
                 //myDoubleClick(selRow, selPath);
            	 
            	 if (selPath.getLastPathComponent() instanceof Configuration)
            	 {            		 
            		 mainFrame.getDiagramPanel().changeSelectedDiagram(((Configuration)selPath.getLastPathComponent()).getView().getDiagram());	
            		 mainFrame.getDiagramPanel().repaint();
            		 mainFrame.getDiagramPanel().updateUI();
            		 mainFrame.getDiagramPanel().setVisible(true);
            	 }
            	 
     			if (selPath.getLastPathComponent() instanceof clews.data.Class)
     				((clews.data.Class)selPath.getLastPathComponent()).getView().edit();

     			if (selPath.getLastPathComponent() instanceof Association)
     				((clews.data.Association)selPath.getLastPathComponent()).getView().edit();
     			
     			if (selPath.getLastPathComponent() instanceof Constraint)
     				((clews.data.Constraint)selPath.getLastPathComponent()).getView().edit();
     			
     			
     			((DomainTreeModel)this.getModel()).getSpecification().applyChanges();
         		
            	 
            	 if (selRow == 1)
            	 {
            		 mainFrame.getDiagramPanel().changeSelectedDiagram(
            				 mainFrame.getDomain().getSpecification().getView().getDiagram());
            		 rootSelPath = selPath;
            		 mainFrame.getDiagramPanel().repaint();            		 
            	 }
             }
         }	
	}

	@Override
	public void mouseReleased(MouseEvent e) {
		// TODO Auto-generated method stub
	//	System.out.println(rootSelPath);
	//	if (rootSelPath != null)
	//		setExpandedState(rootSelPath, true);
	}
	
}
