package clews.gui;

import java.awt.datatransfer.Transferable;

import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.io.IOException;
import javax.swing.tree.TreePath;

import clews.MainFrame;
import clews.gui.diagram.DiagramPanel;

public class PanelDropTarget implements DropTargetListener {

	protected DiagramPanel targetPanel;
	DropTarget target;
	
	public PanelDropTarget(DiagramPanel panel)
	{
		targetPanel = panel;
	    target = new DropTarget(targetPanel, this);	
	}
	
	public clews.data.Class extractClass(Transferable t)
	{
		clews.data.Class ret = null;
		// TODO is this good? 
		try {

			Object tmp = t.getTransferData(TransferableTreeItem.TREE_PATH_FLAVOR);
			if (tmp instanceof TreePath){
				TreePath tp = MainFrame.getInstance().getDomainTree().getSelectionPath();
				if (tp.getLastPathComponent() instanceof clews.data.Class)
					ret = (clews.data.Class)tp.getLastPathComponent();
			}				
		
		} catch (UnsupportedFlavorException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}	
		return ret;
	}
	
	public void doAccept(DropTargetDragEvent dtde)
	{
		if (dtde.getTransferable().isDataFlavorSupported(TransferableTreeItem.TREE_PATH_FLAVOR))
			dtde.acceptDrag(dtde.getDropAction());									
		else
			dtde.rejectDrag(); 
	}
	
	@Override
	public void dragEnter(DropTargetDragEvent dtde) {
		// TODO Auto-generated method stub
		doAccept(dtde);
	
	}

	@Override
	public void dragExit(DropTargetEvent dtde) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dragOver(DropTargetDragEvent dtde) {
		// TODO Auto-generated method stub
		doAccept(dtde);
	}

	@Override
	public void drop(DropTargetDropEvent dtde) {

		dtde.acceptDrop(dtde.getDropAction());
		clews.data.Class c = extractClass(dtde.getTransferable());		
		targetPanel.classDroped(c,dtde.getLocation());
		dtde.dropComplete(true);
	}

	@Override
	public void dropActionChanged(DropTargetDragEvent dtde) {
		// TODO Auto-generated method stub
		
	}	

}
