package clews.gui;


import java.awt.datatransfer.Transferable;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragGestureRecognizer;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;

import javax.swing.tree.TreePath;

import clews.MainFrame;
import clews.gui.diagram.ConfigurationDiagram;
import clews.gui.diagram.SpecificationDiagram;


class TreeDragSource implements DragSourceListener, DragGestureListener 
{
	protected DragSource source;
	protected DragGestureRecognizer recognizer;
	protected DomainTree sourceTree;
	
	public TreeDragSource(DomainTree tree, int actions)
	{
		sourceTree = tree;
		source = new DragSource();
		recognizer = source.createDefaultDragGestureRecognizer(sourceTree,actions, this);
	}
	
	@Override
	public void dragDropEnd(DragSourceDropEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dragEnter(DragSourceDragEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dragExit(DragSourceEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dragOver(DragSourceDragEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dropActionChanged(DragSourceDragEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void dragGestureRecognized(DragGestureEvent dge) {
		// TODO Auto-generated method stub
		TreePath path = sourceTree.getSelectionPath();
	    if (path.getLastPathComponent() instanceof clews.data.Class)
	    {
	    	Transferable t = new TransferableTreeItem(path);
	    	if (MainFrame.getInstance().getDiagramPanel().getDiagram() instanceof ConfigurationDiagram)
	    		source.startDrag(dge, DragSource.DefaultCopyDrop, t, this);
	    }

	    if (path.getLastPathComponent().equals(((DomainTreeModel)sourceTree.getModel()).getClassGroup()))
	    {	    	
	    	Transferable t = new TransferableTreeItem(path);
	    	if (MainFrame.getInstance().getDiagramPanel().getDiagram() instanceof SpecificationDiagram)
	    		source.startDrag(dge, DragSource.DefaultCopyDrop, t, this);
	    }
	}

}