package clews.gui.diagram;

import java.awt.Graphics2D;
import java.util.ArrayList;

import clews.MainFrame;
import clews.History.Operation;
import clews.gui.view.AssociationView;
import clews.gui.view.ClassView;
import clews.gui.view.PickableObject;
import clews.gui.view.SpecificationView;

public class SpecificationDiagram
extends Diagram<ClassView, AssociationView>
{
	protected SpecificationView specificationView;
	
	public SpecificationDiagram(SpecificationView sv)
	{
		super(MainFrame.getInstance().getDiagramPanel());		
		specificationView = sv;
	}
	
	public String getName()
	{
		return "Specification";
	}
	
	public void connect(PickableObject po1, PickableObject po2)
    {
		MainFrame.getInstance().getDomain().getHistory().addUndo(null, Operation.ADD, "Association added");
		specificationView.addNewAssociationView(
			specificationView.getSpecification().associate(
				((ClassView)po1).getClassObject(),((ClassView)po2).getClassObject()));
		applyChanges();
    }
	
	@Override
	public void draw(Graphics2D g) {
		if (specificationView != null)
			specificationView.draw(g);
		super.draw(g);
	}

	@Override
	public ArrayList<ClassView> getPickableObjects() {
		if (specificationView != null)
			return specificationView.getClasses();
		return new ArrayList<ClassView>();
	}

	@Override
	public ArrayList<AssociationView> getSelectableObjects() {
		if (specificationView != null)
			return specificationView.getAssociations();
		return new ArrayList<AssociationView>();
		
	}

	@Override
	public void applyChanges() {
		specificationView.applyChanges();
		MainFrame.getInstance().update();				
	}
}
