package clews.gui.dialogs;

import java.awt.BorderLayout;


import java.awt.Container;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import clews.MainFrame;
import clews.env.Environment;
import clews.env.Utils;


public class EditClassDialog 
extends JDialog
{

	private static final long serialVersionUID = -9166600668896259280L;
	protected JTextField classname;
	protected JTextField minobj,weight,maxobj,minpartner,maxpartner;
	protected clews.data.Class data;
	
	public EditClassDialog(clews.data.Class c)
	{
		super(MainFrame.getInstance(),"Edit Class",Dialog.ModalityType.DOCUMENT_MODAL);
		Environment.CURRENT_DIALOG = this;
		data = c;
		Container parent = getContentPane();
	
		
		parent.setLayout(new BorderLayout());
		
		JPanel p1 = new JPanel(new GridLayout(6,2));
		
//		JPanel p1 = new JPanel(new FlowLayout());
		p1.add(new JLabel("Name: "));
		classname = new JTextField(c.getName(),15);
		p1.add(classname);
		
		minobj = new JTextField(""+c.getMinObj(),5);
		p1.add(new JLabel("Minimum Objects: "));
		p1.add(minobj);
		
		weight = new JTextField(""+c.getWeight(),5);
		p1.add(new JLabel("Weight: "));
		p1.add(weight);
		
		maxobj = new JTextField(Utils.toStarNum(c.getMaxObj()),5);
		p1.add(new JLabel("Maximum Objects: "));
		p1.add(maxobj);
		
		minpartner = new JTextField(""+c.getMinPartner(),5);
		p1.add(new JLabel("OR Minimum: "));
		p1.add(minpartner);
		
		maxpartner = new JTextField(Utils.toStarNum(c.getMaxParnter()),5);
		p1.add(new JLabel("OR Maximum: "));
		p1.add(maxpartner);
		
		JPanel p3 = new JPanel(new FlowLayout());
		JButton ok = new JButton("Ok");
		JButton cancel = new JButton("Cancel");
		JButton delete = new JButton("Delete");
		p3.add(delete);
		p3.add(cancel);
		p3.add(ok);
		
		parent.add(p1,BorderLayout.NORTH);
		parent.add(p3,BorderLayout.EAST);
		
		ok.addActionListener(new OkListener());
		cancel.addActionListener(new CancelListener());
		delete.addActionListener(new DeleteListener());
		
//		parent.add(p1);
//		parent.add(p2);
//		parent.add(p3);
		
		setResizable(false);
		setLocationRelativeTo(MainFrame.getInstance());
		pack();
	}
	
	public void close()
	{
		Environment.CURRENT_DIALOG = null;
		setVisible(false);
	}

	class OkListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (classname != null && !classname.getText().equals(""))
				data.setName(classname.getText());
			if (minobj != null && Utils.isInteger(minobj.getText()))
				data.setMinObj(Integer.parseInt(minobj.getText()));
			if (weight != null && Utils.isInteger(weight.getText()))
				data.setWeight(Integer.parseInt(weight.getText()));
			if (maxobj != null)				
				data.setMaxObj(Utils.fromStarNum(maxobj.getText(), data.getMaxObj()));
			if (minpartner != null && Utils.isInteger(minpartner.getText()))
				data.setMinPartner(Integer.parseInt(minpartner.getText()));
			if (maxpartner != null)
				data.setMaxPartner(Utils.fromStarNum(maxpartner.getText(), data.getMaxParnter()));
			close();
		}		
	}

	class CancelListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			close();
		}		
	}
	
	class DeleteListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			data.getView().delete();
			close();
		}		
	}
}
