package clews.gui.dialogs;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import clews.MainFrame;
import clews.data.Instance;
import clews.env.Environment;


public class EditInstanceDialog 
extends JDialog
{
	private static final long serialVersionUID = 2357721513181689005L;
	protected JTextField instancename;
	protected Instance instance;
	
	public EditInstanceDialog(Instance i)
	{
		super(MainFrame.getInstance(),"Edit Instance",Dialog.ModalityType.DOCUMENT_MODAL);
		Environment.CURRENT_DIALOG = this;
		instance = i;
		Container parent = getContentPane();
	
		
		parent.setLayout(new BorderLayout());
		
		JPanel p1 = new JPanel(new FlowLayout());//new GridLayout(1,2));
		

		p1.add(new JLabel("Name: "));
		instancename = new JTextField(i.getName(),15);
		p1.add(instancename);
		
		JPanel p3 = new JPanel(new FlowLayout());
		JButton ok = new JButton("Ok");
		JButton cancel = new JButton("Cancel");
		JButton delete = new JButton("Delete");
		p3.add(delete);
		p3.add(cancel);
		p3.add(ok);
		
		parent.add(p1,BorderLayout.NORTH);
		parent.add(p3,BorderLayout.EAST);
		
		ok.addActionListener(new OkListener());
		cancel.addActionListener(new CancelListener());
		delete.addActionListener(new DeleteListener());

		setResizable(false);
		setLocationRelativeTo(MainFrame.getInstance());
		pack();
	}

	public void close()
	{
		Environment.CURRENT_DIALOG = null;
		setVisible(false);
	}
	
	class OkListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			if (instancename != null && !instancename.getText().equals(""))
				instance.setName(instancename.getText());
			close();
		}		
	}

	class CancelListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			close();
		}		
	}
	
	class DeleteListener implements ActionListener
	{
		@Override
		public void actionPerformed(ActionEvent arg0) {
			instance.getView().delete();
			close();
		}		
	}

}
