package clews.gui.view;

import java.awt.Graphics2D;
import java.awt.Rectangle;

import java.awt.geom.Point2D;

import clews.MainFrame;
import clews.History.Operation;
import clews.data.Constraint;
import clews.env.Environment;
import clews.gui.dialogs.EditClassDialog;
import clews.gui.dialogs.EditConstraintDialog;

public class ConstraintView
extends SelectableObject
{
	protected Constraint constraint;
	
	public ConstraintView(Constraint c)
	{
		constraint = c;
	}

	@Override
	public void clicked(Point2D p) {};

	@Override
	public boolean contains(Point2D p) 
	{
		return false;
	}

	@Override
	public void mark() {
	}

	@Override
	public void release() {
	}

	@Override
	public void rightClicked(Point2D p) {
	}

	@Override
	public boolean setOver(boolean isOver) {
		return false;
	}

	@Override
	public void unmark() {
	}

	@Override
	public void draw(Graphics2D g) {
	}

	@Override
	public void delete() {
		MainFrame.getInstance().getDomain().getHistory().addUndo(this, Operation.DELETE, "Constraint deleted");
		constraint.getSpecification().delete(constraint);
		clews.MainFrame.getInstance().update();
	}
	
	@Override
	public void edit() {
		if (!Environment.IS_CONTROL_DOWN){
			try{
				MainFrame.getInstance().getDomain().getHistory().addUndo(this, Operation.CHANGE, "Constraint changed");
				EditConstraintDialog ecd = new EditConstraintDialog(constraint);
				ecd.setVisible(true);
				//constraint.getSpecification().getView().applyChanges(); TODO
				clews.MainFrame.getInstance().update();
			}catch (Exception ex)
			{
				// TODO: maybe java-bug occurs
			}
		}
	}

	@Override
	public Rectangle getPrintBounds() {
		return null;
	}

	@Override
	public boolean isOver() {
		// TODO Auto-generated method stub
		return false;
	}
}
