package clews.gui.view;

import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

public abstract class PickableObject
extends SelectableObject
{
	protected boolean isSelected;
	protected boolean positionChanged;

	public PickableObject()
	{
		this(false);
	}
	
	public PickableObject(boolean isEditable)
	{
		super(isEditable);
		isSelected = false;		
		positionChanged = false;
	}
	
	public boolean hasPositionChanged()
	{
		return positionChanged;
	}
	
	public void setPositionChanged()
	{
		positionChanged = true;
	}
	
	public void setSelected(boolean sel)
	{
		isSelected = sel;
	}
	
	public boolean isSelected()
	{
		return isSelected;
	}
	
	public abstract Rectangle getBounds();
	public abstract void setLocation(Point p);
	public abstract void updateLocation(Point2D p);
	
	public void setLocation(int x, int y)
	{
		setLocation(new Point(x,y));
	}
}
