package clews.gui.view;

import java.awt.Color;
import java.awt.geom.Point2D;

public abstract class SelectableObject
extends ViewObject
{
	protected Color color;	
	protected boolean isEditable;
	
	public SelectableObject()
	{
		this(false);
	}
	
	public SelectableObject(boolean isEditable)
	{
		this.isEditable = isEditable;		
	}
	
	public void edit(){}	
	public void delete(){}
	
	public abstract void mark();
	public abstract void unmark();
	public abstract boolean setOver(boolean isOver);
	public abstract boolean isOver();
	 
	public abstract void release();
	
	public abstract boolean contains(Point2D p);
	public abstract void clicked(Point2D p);	
	public abstract void rightClicked(Point2D p);
	
	public void doubleClicked(Point2D p)
	{
		if (isEditable)
			edit();
	}
}
